#include <dockapp.h>
#include <unistd.h>

#include <string.h>

#include "engine.h"

#define WMFONT "-*-fixed-medium-r-*-*-8-*-*-*-*-*-*-*"

extern char *value[10], *paikka, *klo, *pvm, *testi;
extern char *valname[10];
extern char bf[1000];
extern char bf2[7][1000];

char *wmfont=NULL;
Font fname;
int fx,fy;

GC gc;
Pixmap pixmap;
char buf[20][50];

time_t updateTime=0; /* s */
int waitTime = 30; /* minuuteissa */

short scr=0;

char *displayName = "";
char *cityName = "";

static DAProgramOption options[] = {
  {"-time", NULL, "update time in minutes", DOInteger, False, {&waitTime}}, 
  {"-city", NULL, "city of Finland to display", DOString, False, {&cityName}},
    {"-display", NULL, "display to use", DOString, False, {&displayName}}
};

void buttonrelease(XButtonEvent *xev);
void buttonpress(XButtonEvent *xev);
void font_init(void);
void setTimes(void);

void firstscr(void);
void secondscr(void);
void thirdscr(void);

int main(int argc, char *argv[])
{
  //  saa Saa;

    int i,j,k;

    DAParseArguments(argc, argv, options,
		     sizeof(options)/sizeof(DAProgramOption),
		     "WMFW dockapp", "WMFW 0.1");

    DAInitialize(displayName, "WMFW", 58, 58, argc, argv);
    pixmap = DAMakePixmap();
    gc = DefaultGC(DADisplay, DefaultScreen(DADisplay));
    font_init();

    XSetFont(DADisplay, gc, fname);

    DAShow();

    while (1) {
	XEvent ev;
	i = j = k = 0;

	if(( updateTime - time(NULL) < 0))
	{
	  /*	  haeSaa("Lahti");*/
	  haeSaa(cityName);
	  setTimes();

	sprintf(buf[k++], "%s", paikka);
	sprintf(buf[k++], "%s", pvm);
	sprintf(buf[k++], "%s", klo);

	for(i=0; valname[i]!=NULL; i++)
	  {
	    printf("%s\n",valname[i]);
	    //ainakin pilvisyydest pois </B>
	    for(j=0; value[i][j] != '<' && value[i][j] != 0; j++);
	    value[i][j] = 0;
	    sprintf(buf[k++], "%s:",valname[i] );
	    sprintf(buf[k++], "%s %s",value[i],yksikko(valname[i]) );
	  }

	}

	XSetForeground(DADisplay, gc, 
		       BlackPixel(DADisplay, DefaultScreen(DADisplay)));
	XFillRectangle(DADisplay, pixmap, gc, 0, 0, 58, 58);

	XSetForeground(DADisplay, gc, 
		       WhitePixel(DADisplay, DefaultScreen(DADisplay)));

	if(scr == 0)
	  firstscr();
	if(scr == 1)
	  secondscr();
	if(scr == 2)
	  thirdscr();

	DASetPixmap(pixmap);

         XSelectInput(DADisplay, DAWindow, ButtonPressMask | ButtonReleaseMask | ExposureMask);
	/* handle all pending X events */
	while (XPending(DADisplay)) {
	    XNextEvent(DADisplay, &ev);
      switch(ev.type) {
      case ButtonPress:
        buttonpress(&ev.xbutton);
	break;
      case ButtonRelease:
	buttonrelease(&ev.xbutton);
	break;}
	    DAProcessEvent(&ev);
	}

	usleep(10000);
    }
  return 0;
}

void buttonrelease(XButtonEvent *xev)
{
 
  scr++;
  if(scr>2)
    scr=0;
	XSetForeground(DADisplay, gc, 
		       BlackPixel(DADisplay, DefaultScreen(DADisplay)));
	XFillRectangle(DADisplay, pixmap, gc, 0, 0, 58, 58);

	XSetForeground(DADisplay, gc, 
		       WhitePixel(DADisplay, DefaultScreen(DADisplay)));

	if(scr == 0)
	  firstscr();
	if(scr == 1)
	  secondscr();
	if(scr == 2)
	  thirdscr();

}

void buttonpress(XButtonEvent *xev)
{

 
}

void firstscr(void)
{
  int i;

	for(i=0; i<3; i++)
	  XDrawString(DADisplay, pixmap, gc, 1, ((1+i)*(10)), buf[i], strlen(buf[i]));
	for(i=3; i<5; i++)
	  XDrawString(DADisplay, pixmap, gc, 1, (45+((i-3)*10)), buf[i], strlen(buf[i]));
}

void secondscr(void)
{
  int i;


        XDrawString(DADisplay, pixmap, gc, 1, 10, buf[0], strlen(buf[0]));

	for(i=5; i<9; i++)
	  XDrawString(DADisplay, pixmap, gc, 1, (((i-6)*(10))+35), buf[i], strlen(buf[i]));
}

void thirdscr(void)
{
  int i;

        XDrawString(DADisplay, pixmap, gc, 1, 10, buf[0], strlen(buf[0]));

	for(i=9; i<13; i++)
	  XDrawString(DADisplay, pixmap, gc, 1, (((i-9)*(10))+25), buf[i], strlen(buf[i]));
}


void font_init(void)
{
 /* Initialize fonts
   */
  XFontStruct *xfs;
  char *font;

  font=wmfont;
  if(font==NULL)
    font=WMFONT;
  xfs=XLoadQueryFont(DADisplay, WMFONT);
  
  fname=xfs->fid;
  fx=6-xfs->min_bounds.lbearing;
  fy+=xfs->ascent;
  XFreeFontInfo(NULL, xfs, 1);

}

void setTimes(void)
{
  updateTime = time(NULL)+(60*waitTime);
}
